diff --git a/boot/menhir/parser.ml b/boot/menhir/parser.ml
index 6b6fc22..dce95f7 100644
--- a/boot/menhir/parser.ml
+++ b/boot/menhir/parser.ml
@@ -23620,33 +23661,33 @@ module Tables = struct
         let _startpos = _startpos_x_ in
         let _endpos = _endpos__5_ in
         let _v : (Parsetree.type_kind * Asttypes.private_flag * Parsetree.core_type option) = let priv = 
-# 3602 "parsing/parser.mly"
+# 3630 "parsing/parser.mly"
                                                 ( Public )
-# 23626 "parsing/parser.ml"
+# 23667 "parsing/parser.ml"
          in
         let oty =
           let _1 =
             let x = 
 # 191 "<standard.mly>"
     ( x )
-# 23633 "parsing/parser.ml"
+# 23674 "parsing/parser.ml"
              in
             
 # 126 "<standard.mly>"
     ( Some x )
-# 23638 "parsing/parser.ml"
+# 23679 "parsing/parser.ml"
             
           in
           
-# 2917 "parsing/parser.mly"
+# 2937 "parsing/parser.mly"
     ( _1 )
-# 23644 "parsing/parser.ml"
+# 23685 "parsing/parser.ml"
           
         in
         
-# 2913 "parsing/parser.mly"
+# 2933 "parsing/parser.mly"
       ( (Ptype_record ls, priv, oty) )
-# 23650 "parsing/parser.ml"
+# 23691 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -23704,33 +23745,33 @@ module Tables = struct
         let _startpos = _startpos_x_ in
         let _endpos = _endpos__5_ in
         let _v : (Parsetree.type_kind * Asttypes.private_flag * Parsetree.core_type option) = let priv = 
-# 3603 "parsing/parser.mly"
+# 3631 "parsing/parser.mly"
                                                 ( Private )
-# 23710 "parsing/parser.ml"
+# 23751 "parsing/parser.ml"
          in
         let oty =
           let _1 =
             let x = 
 # 191 "<standard.mly>"
     ( x )
-# 23717 "parsing/parser.ml"
+# 23758 "parsing/parser.ml"
              in
             
 # 126 "<standard.mly>"
     ( Some x )
-# 23722 "parsing/parser.ml"
+# 23763 "parsing/parser.ml"
             
           in
           
-# 2917 "parsing/parser.mly"
+# 2937 "parsing/parser.mly"
     ( _1 )
-# 23728 "parsing/parser.ml"
+# 23769 "parsing/parser.ml"
           
         in
         
-# 2913 "parsing/parser.mly"
+# 2933 "parsing/parser.mly"
       ( (Ptype_record ls, priv, oty) )
-# 23734 "parsing/parser.ml"
+# 23775 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -23783,37 +23824,37 @@ module Tables = struct
         let _v : (Parsetree.open_declaration * string Asttypes.loc option) = let attrs2 =
           let _1 = _1_inlined2 in
           
-# 3743 "parsing/parser.mly"
+# 3771 "parsing/parser.mly"
     ( _1 )
-# 23789 "parsing/parser.ml"
+# 23830 "parsing/parser.ml"
           
         in
         let _endpos_attrs2_ = _endpos__1_inlined2_ in
         let attrs1 =
           let _1 = _1_inlined1 in
           
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 23798 "parsing/parser.ml"
+# 23839 "parsing/parser.ml"
           
         in
         let override = 
-# 3649 "parsing/parser.mly"
+# 3677 "parsing/parser.mly"
                                                 ( Fresh )
-# 23804 "parsing/parser.ml"
+# 23845 "parsing/parser.ml"
          in
         let _endpos = _endpos_attrs2_ in
         let _symbolstartpos = _startpos__1_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 1474 "parsing/parser.mly"
+# 1482 "parsing/parser.mly"
   (
     let attrs = attrs1 @ attrs2 in
     let loc = make_loc _sloc in
     let docs = symbol_docs _sloc in
     Opn.mk me ~override ~attrs ~loc ~docs, ext
   )
-# 23817 "parsing/parser.ml"
+# 23858 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -23873,40 +23914,40 @@ module Tables = struct
         let _v : (Parsetree.open_declaration * string Asttypes.loc option) = let attrs2 =
           let _1 = _1_inlined3 in
           
-# 3743 "parsing/parser.mly"
+# 3771 "parsing/parser.mly"
     ( _1 )
-# 23879 "parsing/parser.ml"
+# 23920 "parsing/parser.ml"
           
         in
         let _endpos_attrs2_ = _endpos__1_inlined3_ in
         let attrs1 =
           let _1 = _1_inlined2 in
           
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 23888 "parsing/parser.ml"
+# 23929 "parsing/parser.ml"
           
         in
         let override =
           let _1 = _1_inlined1 in
           
-# 3650 "parsing/parser.mly"
+# 3678 "parsing/parser.mly"
                                                 ( Override )
-# 23896 "parsing/parser.ml"
+# 23937 "parsing/parser.ml"
           
         in
         let _endpos = _endpos_attrs2_ in
         let _symbolstartpos = _startpos__1_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 1474 "parsing/parser.mly"
+# 1482 "parsing/parser.mly"
   (
     let attrs = attrs1 @ attrs2 in
     let loc = make_loc _sloc in
     let docs = symbol_docs _sloc in
     Opn.mk me ~override ~attrs ~loc ~docs, ext
   )
-# 23910 "parsing/parser.ml"
+# 23951 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -23959,9 +24000,9 @@ module Tables = struct
         let _v : (Parsetree.open_description * string Asttypes.loc option) = let attrs2 =
           let _1 = _1_inlined3 in
           
-# 3743 "parsing/parser.mly"
+# 3771 "parsing/parser.mly"
     ( _1 )
-# 23965 "parsing/parser.ml"
+# 24006 "parsing/parser.ml"
           
         in
         let _endpos_attrs2_ = _endpos__1_inlined3_ in
@@ -23971,36 +24012,36 @@ module Tables = struct
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 23977 "parsing/parser.ml"
+# 24018 "parsing/parser.ml"
           
         in
         let attrs1 =
           let _1 = _1_inlined1 in
           
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 23985 "parsing/parser.ml"
+# 24026 "parsing/parser.ml"
           
         in
         let override = 
-# 3649 "parsing/parser.mly"
+# 3677 "parsing/parser.mly"
                                                 ( Fresh )
-# 23991 "parsing/parser.ml"
+# 24032 "parsing/parser.ml"
          in
         let _endpos = _endpos_attrs2_ in
         let _symbolstartpos = _startpos__1_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 1489 "parsing/parser.mly"
+# 1497 "parsing/parser.mly"
   (
     let attrs = attrs1 @ attrs2 in
     let loc = make_loc _sloc in
     let docs = symbol_docs _sloc in
     Opn.mk id ~override ~attrs ~loc ~docs, ext
   )
-# 24004 "parsing/parser.ml"
+# 24045 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24060,9 +24101,9 @@ module Tables = struct
         let _v : (Parsetree.open_description * string Asttypes.loc option) = let attrs2 =
           let _1 = _1_inlined4 in
           
-# 3743 "parsing/parser.mly"
+# 3771 "parsing/parser.mly"
     ( _1 )
-# 24066 "parsing/parser.ml"
+# 24107 "parsing/parser.ml"
           
         in
         let _endpos_attrs2_ = _endpos__1_inlined4_ in
@@ -24072,39 +24113,39 @@ module Tables = struct
           let _symbolstartpos = _startpos__1_ in
           let _sloc = (_symbolstartpos, _endpos) in
           
-# 817 "parsing/parser.mly"
+# 825 "parsing/parser.mly"
     ( mkrhs _1 _sloc )
-# 24078 "parsing/parser.ml"
+# 24119 "parsing/parser.ml"
           
         in
         let attrs1 =
           let _1 = _1_inlined2 in
           
-# 3747 "parsing/parser.mly"
+# 3775 "parsing/parser.mly"
     ( _1 )
-# 24086 "parsing/parser.ml"
+# 24127 "parsing/parser.ml"
           
         in
         let override =
           let _1 = _1_inlined1 in
           
-# 3650 "parsing/parser.mly"
+# 3678 "parsing/parser.mly"
                                                 ( Override )
-# 24094 "parsing/parser.ml"
+# 24135 "parsing/parser.ml"
           
         in
         let _endpos = _endpos_attrs2_ in
         let _symbolstartpos = _startpos__1_ in
         let _sloc = (_symbolstartpos, _endpos) in
         
-# 1489 "parsing/parser.mly"
+# 1497 "parsing/parser.mly"
   (
     let attrs = attrs1 @ attrs2 in
     let loc = make_loc _sloc in
     let docs = symbol_docs _sloc in
     Opn.mk id ~override ~attrs ~loc ~docs, ext
   )
-# 24108 "parsing/parser.ml"
+# 24149 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24123,17 +24164,17 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let _1 : (
-# 675 "parsing/parser.mly"
+# 683 "parsing/parser.mly"
        (string)
-# 24129 "parsing/parser.ml"
+# 24170 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = 
-# 3445 "parsing/parser.mly"
+# 3465 "parsing/parser.mly"
                                                 ( _1 )
-# 24137 "parsing/parser.ml"
+# 24178 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24152,17 +24193,17 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let _1 : (
-# 633 "parsing/parser.mly"
+# 641 "parsing/parser.mly"
        (string)
-# 24158 "parsing/parser.ml"
+# 24199 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = 
-# 3446 "parsing/parser.mly"
+# 3466 "parsing/parser.mly"
                                                 ( _1 )
-# 24166 "parsing/parser.ml"
+# 24207 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24181,17 +24222,17 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let _1 : (
-# 634 "parsing/parser.mly"
+# 642 "parsing/parser.mly"
        (string)
-# 24187 "parsing/parser.ml"
+# 24228 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = 
-# 3447 "parsing/parser.mly"
+# 3467 "parsing/parser.mly"
                                                 ( _1 )
-# 24195 "parsing/parser.ml"
+# 24236 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24231,17 +24272,17 @@ module Tables = struct
         let _3 : (string) = Obj.magic _3 in
         let _2 : unit = Obj.magic _2 in
         let _1 : (
-# 632 "parsing/parser.mly"
+# 640 "parsing/parser.mly"
        (string)
-# 24237 "parsing/parser.ml"
+# 24278 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__4_ in
         let _v : (Asttypes.label) = 
-# 3448 "parsing/parser.mly"
+# 3468 "parsing/parser.mly"
                                                 ( "."^ _1 ^"(" ^ _3 ^ ")" )
-# 24245 "parsing/parser.ml"
+# 24286 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24288,17 +24329,17 @@ module Tables = struct
         let _3 : (string) = Obj.magic _3 in
         let _2 : unit = Obj.magic _2 in
         let _1 : (
-# 632 "parsing/parser.mly"
+# 640 "parsing/parser.mly"
        (string)
-# 24294 "parsing/parser.ml"
+# 24335 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__5_ in
         let _v : (Asttypes.label) = 
-# 3449 "parsing/parser.mly"
+# 3469 "parsing/parser.mly"
                                                 ( "."^ _1 ^ "(" ^ _3 ^ ")<-" )
-# 24302 "parsing/parser.ml"
+# 24343 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24338,17 +24379,17 @@ module Tables = struct
         let _3 : (string) = Obj.magic _3 in
         let _2 : unit = Obj.magic _2 in
         let _1 : (
-# 632 "parsing/parser.mly"
+# 640 "parsing/parser.mly"
        (string)
-# 24344 "parsing/parser.ml"
+# 24385 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__4_ in
         let _v : (Asttypes.label) = 
-# 3450 "parsing/parser.mly"
+# 3470 "parsing/parser.mly"
                                                 ( "."^ _1 ^"[" ^ _3 ^ "]" )
-# 24352 "parsing/parser.ml"
+# 24393 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24395,17 +24436,17 @@ module Tables = struct
         let _3 : (string) = Obj.magic _3 in
         let _2 : unit = Obj.magic _2 in
         let _1 : (
-# 632 "parsing/parser.mly"
+# 640 "parsing/parser.mly"
        (string)
-# 24401 "parsing/parser.ml"
+# 24442 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__5_ in
         let _v : (Asttypes.label) = 
-# 3451 "parsing/parser.mly"
+# 3471 "parsing/parser.mly"
                                                 ( "."^ _1 ^ "[" ^ _3 ^ "]<-" )
-# 24409 "parsing/parser.ml"
+# 24450 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24445,17 +24486,17 @@ module Tables = struct
         let _3 : (string) = Obj.magic _3 in
         let _2 : unit = Obj.magic _2 in
         let _1 : (
-# 632 "parsing/parser.mly"
+# 640 "parsing/parser.mly"
        (string)
-# 24451 "parsing/parser.ml"
+# 24492 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__4_ in
         let _v : (Asttypes.label) = 
-# 3452 "parsing/parser.mly"
+# 3472 "parsing/parser.mly"
                                                 ( "."^ _1 ^"{" ^ _3 ^ "}" )
-# 24459 "parsing/parser.ml"
+# 24500 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24502,17 +24543,17 @@ module Tables = struct
         let _3 : (string) = Obj.magic _3 in
         let _2 : unit = Obj.magic _2 in
         let _1 : (
-# 632 "parsing/parser.mly"
+# 640 "parsing/parser.mly"
        (string)
-# 24508 "parsing/parser.ml"
+# 24549 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__5_ in
         let _v : (Asttypes.label) = 
-# 3453 "parsing/parser.mly"
+# 3473 "parsing/parser.mly"
                                                 ( "."^ _1 ^ "{" ^ _3 ^ "}<-" )
-# 24516 "parsing/parser.ml"
+# 24557 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24531,17 +24572,17 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let _1 : (
-# 686 "parsing/parser.mly"
+# 694 "parsing/parser.mly"
        (string)
-# 24537 "parsing/parser.ml"
+# 24578 "parsing/parser.ml"
         ) = Obj.magic _1 in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = 
-# 3454 "parsing/parser.mly"
+# 3474 "parsing/parser.mly"
                                                 ( _1 )
-# 24545 "parsing/parser.ml"
+# 24586 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24564,9 +24605,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = 
-# 3455 "parsing/parser.mly"
+# 3475 "parsing/parser.mly"
                                                 ( "!" )
-# 24570 "parsing/parser.ml"
+# 24611 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24585,22 +24626,33 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let op : (
-# 627 "parsing/parser.mly"
+# 635 "parsing/parser.mly"
        (string)
-# 24591 "parsing/parser.ml"
+# 24632 "parsing/parser.ml"
         ) = Obj.magic op in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos_op_ in
         let _endpos = _endpos_op_ in
-        let _v : (Asttypes.label) = let _1 = 
-# 3459 "parsing/parser.mly"
-                  ( op )
-# 24599 "parsing/parser.ml"
-         in
+        let _v : (Asttypes.label) = let _1 =
+          let _endpos = _endpos_op_ in
+          let _startpos = _startpos_op_ in
+          let _loc = (_startpos, _endpos) in
+          
+# 3479 "parsing/parser.mly"
+                  ( if language_level < 4
+                    then begin match op with
+                             "==" -> infixop0 ~loc:_loc "="
+                           | "!=" -> infixop0 ~loc:_loc "<>"
+                           | _ -> op
+                         end
+                    else op )
+# 24650 "parsing/parser.ml"
+          
+        in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24604 "parsing/parser.ml"
+# 24656 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24619,22 +24671,22 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let op : (
-# 628 "parsing/parser.mly"
+# 636 "parsing/parser.mly"
        (string)
-# 24625 "parsing/parser.ml"
+# 24677 "parsing/parser.ml"
         ) = Obj.magic op in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos_op_ in
         let _endpos = _endpos_op_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3460 "parsing/parser.mly"
+# 3486 "parsing/parser.mly"
                   ( op )
-# 24633 "parsing/parser.ml"
+# 24685 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24638 "parsing/parser.ml"
+# 24690 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24653,22 +24705,22 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let op : (
-# 629 "parsing/parser.mly"
+# 637 "parsing/parser.mly"
        (string)
-# 24659 "parsing/parser.ml"
+# 24711 "parsing/parser.ml"
         ) = Obj.magic op in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos_op_ in
         let _endpos = _endpos_op_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3461 "parsing/parser.mly"
+# 3487 "parsing/parser.mly"
                   ( op )
-# 24667 "parsing/parser.ml"
+# 24719 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24672 "parsing/parser.ml"
+# 24724 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24687,22 +24739,22 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let op : (
-# 630 "parsing/parser.mly"
+# 638 "parsing/parser.mly"
        (string)
-# 24693 "parsing/parser.ml"
+# 24745 "parsing/parser.ml"
         ) = Obj.magic op in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos_op_ in
         let _endpos = _endpos_op_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3462 "parsing/parser.mly"
+# 3488 "parsing/parser.mly"
                   ( op )
-# 24701 "parsing/parser.ml"
+# 24753 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24706 "parsing/parser.ml"
+# 24758 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24721,22 +24773,22 @@ module Tables = struct
           MenhirLib.EngineTypes.next = _menhir_stack;
         } = _menhir_stack in
         let op : (
-# 631 "parsing/parser.mly"
+# 639 "parsing/parser.mly"
        (string)
-# 24727 "parsing/parser.ml"
+# 24779 "parsing/parser.ml"
         ) = Obj.magic op in
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos_op_ in
         let _endpos = _endpos_op_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3463 "parsing/parser.mly"
+# 3489 "parsing/parser.mly"
                   ( op )
-# 24735 "parsing/parser.ml"
+# 24787 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24740 "parsing/parser.ml"
+# 24792 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24759,14 +24811,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3464 "parsing/parser.mly"
+# 3490 "parsing/parser.mly"
                    ("+")
-# 24765 "parsing/parser.ml"
+# 24817 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24770 "parsing/parser.ml"
+# 24822 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24789,14 +24841,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3465 "parsing/parser.mly"
+# 3491 "parsing/parser.mly"
                   ("+.")
-# 24795 "parsing/parser.ml"
+# 24847 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24800 "parsing/parser.ml"
+# 24852 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24819,14 +24871,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3466 "parsing/parser.mly"
+# 3492 "parsing/parser.mly"
                   ("+=")
-# 24825 "parsing/parser.ml"
+# 24877 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24830 "parsing/parser.ml"
+# 24882 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24849,14 +24901,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3467 "parsing/parser.mly"
+# 3493 "parsing/parser.mly"
                    ("-")
-# 24855 "parsing/parser.ml"
+# 24907 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24860 "parsing/parser.ml"
+# 24912 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24879,14 +24931,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3468 "parsing/parser.mly"
+# 3494 "parsing/parser.mly"
                   ("-.")
-# 24885 "parsing/parser.ml"
+# 24937 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24890 "parsing/parser.ml"
+# 24942 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24909,14 +24961,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3469 "parsing/parser.mly"
+# 3495 "parsing/parser.mly"
                    ("*")
-# 24915 "parsing/parser.ml"
+# 24967 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24920 "parsing/parser.ml"
+# 24972 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24939,14 +24991,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3470 "parsing/parser.mly"
+# 3496 "parsing/parser.mly"
                    ("%")
-# 24945 "parsing/parser.ml"
+# 24997 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24950 "parsing/parser.ml"
+# 25002 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24969,14 +25021,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3471 "parsing/parser.mly"
+# 3497 "parsing/parser.mly"
                    ("=")
-# 24975 "parsing/parser.ml"
+# 25027 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 24980 "parsing/parser.ml"
+# 25032 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -24999,14 +25051,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3472 "parsing/parser.mly"
+# 3498 "parsing/parser.mly"
                    ("<")
-# 25005 "parsing/parser.ml"
+# 25057 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 25010 "parsing/parser.ml"
+# 25062 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -25029,14 +25081,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3473 "parsing/parser.mly"
+# 3499 "parsing/parser.mly"
                    (">")
-# 25035 "parsing/parser.ml"
+# 25087 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 25040 "parsing/parser.ml"
+# 25092 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -25059,14 +25111,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3474 "parsing/parser.mly"
+# 3500 "parsing/parser.mly"
                   ("or")
-# 25065 "parsing/parser.ml"
+# 25117 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 25070 "parsing/parser.ml"
+# 25122 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -25089,14 +25141,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3475 "parsing/parser.mly"
+# 3501 "parsing/parser.mly"
                   ("||")
-# 25095 "parsing/parser.ml"
+# 25147 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 25100 "parsing/parser.ml"
+# 25152 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -25119,14 +25171,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3476 "parsing/parser.mly"
+# 3502 "parsing/parser.mly"
                    ("&")
-# 25125 "parsing/parser.ml"
+# 25177 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 25130 "parsing/parser.ml"
+# 25182 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -25149,14 +25201,14 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (Asttypes.label) = let _1 = 
-# 3477 "parsing/parser.mly"
+# 3503 "parsing/parser.mly"
                   ("&&")
-# 25155 "parsing/parser.ml"
+# 25207 "parsing/parser.ml"
          in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 25160 "parsing/parser.ml"
+# 25212 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -25178,15 +25230,22 @@ module Tables = struct
         let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
-        let _v : (Asttypes.label) = let _1 = 
-# 3478 "parsing/parser.mly"
-                  (":=")
-# 25185 "parsing/parser.ml"
-         in
+        let _v : (Asttypes.label) = let _1 =
+          let _endpos = _endpos__1_ in
+          let _startpos = _startpos__1_ in
+          let _loc = (_startpos, _endpos) in
+          
+# 3504 "parsing/parser.mly"
+                  ( if language_level < 3
+                    then expert_exp ~loc:_loc "assign"
+                    else ":=" )
+# 25243 "parsing/parser.ml"
+          
+        in
         
-# 3456 "parsing/parser.mly"
+# 3476 "parsing/parser.mly"
                                                 ( _1 )
-# 25190 "parsing/parser.ml"
+# 25249 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -25209,9 +25268,9 @@ module Tables = struct
         let _startpos = _startpos__1_ in
         let _endpos = _endpos__1_ in
         let _v : (bool) = 
-# 3360 "parsing/parser.mly"
+# 3380 "parsing/parser.mly"
                                                 ( true )
-# 25215 "parsing/parser.ml"
+# 25274 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
@@ -25227,9 +25286,9 @@ module Tables = struct
         let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
         let _endpos = _startpos in
         let _v : (bool) = 
-# 3361 "parsing/parser.mly"
+# 3381 "parsing/parser.mly"
                                                 ( false )
-# 25233 "parsing/parser.ml"
+# 25292 "parsing/parser.ml"
          in
         {
           MenhirLib.EngineTypes.state = _menhir_s;
